package com.ejie.ab79.dao.expedientes;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.comun.Constantes;
import com.ejie.ab79.model.expedientes.DatosDirecciones;
import com.ejie.ab79.model.expedientes.DatosTerceros;
import com.ejie.ab79.model.expedientes.RelExpTer;
import com.ejie.ab79.model.expedientes.Sexo;
import com.ejie.ab79.model.expedientes.SubtipoTercero;
import com.ejie.ab79.model.expedientes.TiposDocumento;
import com.ejie.ab79.model.expedientes.TiposTercero;
import com.ejie.ab79.model.nora.T17Localidad;
import com.ejie.ab79.model.nora.T17Municipio;
import com.ejie.ab79.model.nora.T17Pais;
import com.ejie.ab79.model.nora.T17Provincia;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RelExpTerDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class RelExpTerDaoImpl implements RelExpTerDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDRELEXPTER", "IDEXPEDIENTE", "IDTIPOTERCERO",
			"FECHAREGISTRO", "USUARIOREGISTRO", "PARTICIPANTID", "FECHAULTMODIFICACION", "USUARIOULTMODIFICACION",
			"DATOSTERCEROSIDTERCERO", "DATOSTERCEROSDOCUMENTO", "DATOSTERCEROSIDTIPODOCUMENTO", "DATOSTERCEROSNOMBRE",
			"DATOSTERCEROSAPELLIDO1", "DATOSTERCEROSAPELLIDO2", "DATOSTERCEROSIDSEXO", "DATOSTERCEROSTELEFONO",
			"DATOSTERCEROSEMAIL", "DATOSTERCEROSIDIOMA", "DATOSTERCEROSTIPOPARTICIPANTE", "DATOSTERCEROSFECHAREGISTRO",
			"DATOSTERCEROSUSUARIOREGISTRO", "DATOSTERCEROSFULTMOD", "DATOSTERCEROSUULTMOD",
			"DATOSTERCEROSIDREPRESENTANTE" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<RelExpTer> rwMap = new RowMapper<RelExpTer>() {
		public RelExpTer mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			RelExpTer relExpTer = new RelExpTer();
			relExpTer.setIdRelExpTer(resultSet.getInt("IDRELEXPTER"));
			relExpTer.setIdExpediente(resultSet.getInt("IDEXPEDIENTE"));
			relExpTer.setParticipantId(resultSet.getString("PARTICIPANTID"));
			relExpTer.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));

			TiposDocumento tipoDocumento = new TiposDocumento();
			tipoDocumento.setIdTipoDocumento(resultSet.getLong("DatosTercerosIDTIPODOCUMENTO"));

			DatosTerceros datosTercero = new DatosTerceros();
			datosTercero.setIdTercero(resultSet.getInt("DatosTercerosIDTERCERO"));
			datosTercero.setDocumento(resultSet.getString("DatosTercerosDOCUMENTO"));
			datosTercero.setNombre(resultSet.getString("DatosTercerosNOMBRE"));
			datosTercero.setApellido1(resultSet.getString("DatosTercerosAPELLIDO1"));
			datosTercero.setApellido2(resultSet.getString("DatosTercerosAPELLIDO2"));
			datosTercero.setSexo(new Sexo(resultSet.getLong("DatosTercerosIDSEXO")));
			datosTercero.setTelefono(resultSet.getLong("DatosTercerosTELEFONO"));
			datosTercero.setEmail(resultSet.getString("DatosTercerosEMAIL"));
			datosTercero.setIdioma(resultSet.getInt("DatosTercerosIDIOMA"));
			datosTercero.setTipoParticipante(resultSet.getInt("DatosTercerosTIPOPARTICIPANTE"));
			datosTercero.setUsuarioRegistro(resultSet.getString("DatosTercerosUSUARIOREGISTRO"));
			datosTercero.setUsuarioUltmodificacion(resultSet.getString("DATOSTERCEROSUULTMOD"));

			TiposTercero tiposTercero = new TiposTercero();
			tiposTercero.setIdTipoTercero(resultSet.getLong("IDTIPOTERCERO"));
			tiposTercero.setDescripcionCastellano(resultSet.getString("DESCRIPCIONCASTELLANO"));
			tiposTercero.setDescripcionEuskera(resultSet.getString("DESCRIPCIONEUSKERA"));

			datosTercero.setTipoDocumento(tipoDocumento);
			relExpTer.setDatosTerceros(datosTercero);
			relExpTer.setTiposTercero(tiposTercero);

			return relExpTer;
		}
	};

	private RowMapper<RelExpTer> rwMapSergio = new RowMapper<RelExpTer>() {
		public RelExpTer mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			RelExpTer relExpTer = new RelExpTer();
			relExpTer.setIdRelExpTer(resultSet.getInt("IDRELEXPTER"));
			relExpTer.setIdExpediente(resultSet.getInt("IDEXPEDIENTE"));
			relExpTer.setParticipantId(resultSet.getString("PARTICIPANTID"));
			relExpTer.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
			relExpTer.setUsuarioUltmodificacion(resultSet.getString("USUARIOULTMODIFICACION"));

			TiposDocumento tipoDocumento = new TiposDocumento();
			tipoDocumento.setIdTipoDocumento(resultSet.getLong("DATOSTERCEROSIDTIPODOCUMENTO"));

			DatosTerceros datosTercero = new DatosTerceros();
			datosTercero.setIdTercero(resultSet.getInt("DATOSTERCEROSIDTERCERO"));
			datosTercero.setDocumento(resultSet.getString("DATOSTERCEROSDOCUMENTO"));
			datosTercero.setNombre(resultSet.getString("DATOSTERCEROSNOMBRE"));
			datosTercero.setApellido1(resultSet.getString("DATOSTERCEROSAPELLIDO1"));
			datosTercero.setApellido2(resultSet.getString("DATOSTERCEROSAPELLIDO2"));
			datosTercero.setSexo(new Sexo(resultSet.getLong("DATOSTERCEROSIDSEXO")));
			datosTercero.setTelefono(resultSet.getLong("DATOSTERCEROSTELEFONO"));
			datosTercero.setEmail(resultSet.getString("DATOSTERCEROSEMAIL"));
			datosTercero.setIdioma(resultSet.getInt("DATOSTERCEROSIDIOMA"));
			datosTercero.setTipoParticipante(resultSet.getInt("DATOSTERCEROSTIPOPARTICIPANTE"));
			datosTercero.setUsuarioRegistro(resultSet.getString("DATOSTERCEROSUSUARIOREGISTRO"));
			datosTercero.setUsuarioUltmodificacion(resultSet.getString("DATOSTERCEROSUULTMOD"));
			datosTercero.setIdRepresentante(resultSet.getInt("DATOSTERCEROSIDREPRESENTANTE"));

			TiposTercero tiposTercero = new TiposTercero();
			tiposTercero.setIdTipoTercero(resultSet.getLong("IDTIPOTERCERO"));

			datosTercero.setTipoDocumento(tipoDocumento);
			relExpTer.setDatosTerceros(datosTercero);
			relExpTer.setTiposTercero(tiposTercero);

			return relExpTer;
		}
	};

	private RowMapper<RelExpTer> rwMapValorParticipacion = new RowMapper<RelExpTer>() {
		public RelExpTer mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			RelExpTer ter = new RelExpTer();
			ter.setParticipantId(resultSet.getString("PARTICIPANTID"));
			ter.setIdRelExpTer(resultSet.getInt("IDRELEXPTER"));

			DatosTerceros datosTerceroAux = new DatosTerceros();
			datosTerceroAux.setIdTercero(resultSet.getInt("IDTERCERO"));
			datosTerceroAux.setDocumento(resultSet.getString("DOCUMENTO"));

			ter.setDatosTerceros(datosTerceroAux);

			return ter;
		}
	};

	private RowMapper<RelExpTer> rwMapParticipantId = new RowMapper<RelExpTer>() {
		public RelExpTer mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			RelExpTer ter = new RelExpTer();
			DatosTerceros datosTercero = new DatosTerceros();
			datosTercero.setIdTercero(resultSet.getInt("DATOSTERCEROSIDTERCERO"));
			datosTercero.setTipoParticipante(resultSet.getInt("TIPOPARTICIPANTE"));
			datosTercero.setDocumento(resultSet.getString("DOCUMENTO"));
			ter.setDatosTerceros(datosTercero);
			ter.setParticipantId(resultSet.getString("PARTICIPANTID"));
			return ter;
		}
	};

	private RowMapper<RelExpTer> rwMapParticipantes = new RowMapper<RelExpTer>() {
		public RelExpTer mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			RelExpTer relExpTer = new RelExpTer();
			DatosTerceros datosTerceroAux = new DatosTerceros();
			TiposTercero tiposTerceroAux = new TiposTercero();
			tiposTerceroAux.setIdTipoTercero(resultSet.getLong("IDTIPOTERCERO"));
			tiposTerceroAux.setDescripcionCastellano(resultSet.getString("DESCRIPCIONCASTELLANO"));
			tiposTerceroAux.setDescripcionEuskera(resultSet.getString("DESCRIPCIONEUSKERA"));

			DatosDirecciones datosDirecciones = new DatosDirecciones();
			datosDirecciones.setIdDireccion(resultSet.getInt("IDDIRECCION"));
			if (resultSet.wasNull()) {
				datosDirecciones.setIdDireccion(null);
			}
			datosDirecciones.setDireccion(resultSet.getString("DIRECCION"));
			datosDirecciones.setCodigoPostal(resultSet.getString("CODIGOPOSTAL"));
			datosDirecciones.setNumero(resultSet.getString("NUMERO"));
			datosDirecciones.setEscalera(resultSet.getString("ESCALERA"));
			datosDirecciones.setPiso(resultSet.getString("PISO"));
			datosDirecciones.setLetra(resultSet.getString("LETRA"));
			datosDirecciones.setDescripcionCiudad(resultSet.getString("DESCRIPCIONCIUDAD"));
			datosDirecciones.setDescripcionProvincia(resultSet.getString("DESCRIPCIONPROVINCIA"));
			datosDirecciones.setComplementoDireccion(resultSet.getString("COMPLEMENTODIRECCION"));

			T17Pais pais = new T17Pais();
			pais.setId(resultSet.getString("IDPAIS"));
			T17Provincia provincia = new T17Provincia();
			provincia.setId(resultSet.getString("IDPROVINCIA"));
			T17Municipio municipio = new T17Municipio();
			municipio.setId(resultSet.getString("IDMUNICIPIO"));
			T17Localidad localidad = new T17Localidad();
			localidad.setId(resultSet.getString("IDLOCALIDAD"));

			datosDirecciones.setPais(pais);
			datosDirecciones.setProvincia(provincia);
			datosDirecciones.setMunicipio(municipio);
			datosDirecciones.setLocalidad(localidad);

			datosTerceroAux.setIdTercero(resultSet.getInt("DATOSTERCEROSIDTERCERO"));
			datosTerceroAux.setNombre(resultSet.getString("NOMBRE"));
			datosTerceroAux.setApellido1(resultSet.getString("APELLIDO1"));
			datosTerceroAux.setApellido2(resultSet.getString("APELLIDO2"));
			datosTerceroAux.setDocumento(resultSet.getString("DOCUMENTO"));
			datosTerceroAux.setTipoParticipante(resultSet.getInt("DATOSTERCEROSTIPOPARTICIPANTE"));
			datosTerceroAux.setDatoDireccion(datosDirecciones);
			relExpTer.setDatosTerceros(datosTerceroAux);
			relExpTer.setTiposTercero(tiposTerceroAux);
			relExpTer.setParticipantId(resultSet.getString("PARTICIPANTID"));
			relExpTer.setOrden(resultSet.getInt("ORDEN"));
			relExpTer.setIdRelExpTer(resultSet.getInt("IDRELEXPTER"));

			SubtipoTercero subtipoTerceroAux = new SubtipoTercero();
			subtipoTerceroAux.setIdSubtipoTercero(resultSet.getInt("IDSUBTIPOTERCERO"));
			if (resultSet.wasNull()) {
				subtipoTerceroAux.setIdSubtipoTercero(null);
			}
			relExpTer.setSubtipoTercero(subtipoTerceroAux);

			return relExpTer;
		}
	};
	private RowMapper<RelExpTer> rwMapPK = new RowMapper<RelExpTer>() {
		public RelExpTer mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new RelExpTer(resultSet.getInt("IDRELEXPTER"));
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */
	/**
	 * Inserts a single row in the RelExpTer table.
	 *
	 * @param relexpter
	 *            RelExpTer
	 * @return RelExpTer
	 */
	public RelExpTer add(RelExpTer relexpter) {

		relexpter.setIdRelExpTer(
				this.jdbcTemplate.queryForObject("SELECT AB61.S_AB6134T00.NEXTVAL FROM DUAL", Integer.class));

		String query = "INSERT INTO REL_EXP_TER (ID_REL_EXP_TER, ID_TERCERO, ID_EXPEDIENTE, ID_TIPO_TERCERO, ID_SUBTIPO_TERCERO, PARTICIPANT_ID, FECHA_REGISTRO, USUARIO_REGISTRO) VALUES (?,?,?,?,?,?,sysdate,?)";
		Object getDatosTercerosIdTerceroAux = null;
		if (relexpter.getDatosTerceros() != null && relexpter.getDatosTerceros().getIdTercero() != null) {
			getDatosTercerosIdTerceroAux = relexpter.getDatosTerceros().getIdTercero();
		}
		Object getTiposTerceroIdTipoTerceroAux = null;
		if (relexpter.getTiposTercero() != null && relexpter.getTiposTercero().getIdTipoTercero() != null) {
			getTiposTerceroIdTipoTerceroAux = relexpter.getTiposTercero().getIdTipoTercero();
		}
		this.jdbcTemplate.update(query, relexpter.getIdRelExpTer(), getDatosTercerosIdTerceroAux,
				relexpter.getIdExpediente(), getTiposTerceroIdTipoTerceroAux, relexpter.getIdSubtipoTercero(),
				relexpter.getParticipantId(), relexpter.getUsuarioRegistro());
		return relexpter;
	}

	public RelExpTer updateSubtipo(RelExpTer relexpter) {

		String query = "UPDATE REL_EXP_TER SET ID_SUBTIPO_TERCERO = ?,	FECHA_ULTMODIFICACION = SYSDATE, USUARIO_ULTMODIFICACION = ? WHERE	PARTICIPANT_ID = ?";

		Object getSubtipoTerceroAux = null;
		if (relexpter.getSubtipoTercero() != null && relexpter.getSubtipoTercero().getIdSubtipoTercero() != null) {
			getSubtipoTerceroAux = relexpter.getSubtipoTercero().getIdSubtipoTercero();
		}

		this.jdbcTemplate.update(query, getSubtipoTerceroAux, relexpter.getUsuarioUltmodificacion(),
				relexpter.getParticipantId());

		return relexpter;
	}

	/**
	 * Finds a single row in the RelExpTer table.
	 *
	 * @param relexpter
	 *            RelExpTer
	 * @return RelExpTer
	 */
	@Transactional(readOnly = true)
	public RelExpTer find(RelExpTer relexpter) {
		String query = "SELECT t1.ID_REL_EXP_TER IDRELEXPTER, t1.ID_EXPEDIENTE IDEXPEDIENTE, t1.ID_TIPO_TERCERO IDTIPOTERCERO, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.PARTICIPANT_ID PARTICIPANTID, t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION, t2.ID_TERCERO DATOSTERCEROSIDTERCERO, t2.DOCUMENTO DATOSTERCEROSDOCUMENTO, t2.ID_TIPO_DOCUMENTO DATOSTERCEROSIDTIPODOCUMENTO, t2.NOMBRE DATOSTERCEROSNOMBRE, t2.APELLIDO1 DATOSTERCEROSAPELLIDO1, t2.APELLIDO2 DATOSTERCEROSAPELLIDO2, t2.ID_SEXO DATOSTERCEROSIDSEXO, t2.TELEFONO DATOSTERCEROSTELEFONO, t2.EMAIL DATOSTERCEROSEMAIL, t2.IDIOMA DATOSTERCEROSIDIOMA, t2.TIPO_PARTICIPANTE DATOSTERCEROSTIPOPARTICIPANTE, t2.FECHA_REGISTRO DATOSTERCEROSFECHAREGISTRO, t2.USUARIO_REGISTRO DATOSTERCEROSUSUARIOREGISTRO, t2.FECHA_ULTMODIFICACION DATOSTERCEROSFULTMOD, t2.USUARIO_ULTMODIFICACION DATOSTERCEROSUULTMOD, t2.ID_REPRESENTANTE DATOSTERCEROSIDREPRESENTANTE, t3.ID_TIPO_TERCERO IDTIPOTERCERO, t3.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t3.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA FROM REL_EXP_TER t1 , DATOS_TERCEROS t2, TIPOS_TERCERO t3  WHERE t1.ID_REL_EXP_TER = ?   AND t1.ID_TERCERO= t2.ID_TERCERO(+) AND t1.ID_TIPO_TERCERO = t3.ID_TIPO_TERCERO";

		List<RelExpTer> relexpterList = this.jdbcTemplate.query(query, this.rwMap, relexpter.getIdRelExpTer());
		return (RelExpTer) DataAccessUtils.uniqueResult(relexpterList);
	}

	/**
	 * buscar valor de participaciones
	 *
	 * @param relexpter
	 *            RelExpTer
	 * @return RelExpTer
	 */
	@Transactional(readOnly = true)
	public List<RelExpTer> findValorParticipant(Integer idExpediente) {

		String query = "SELECT T1.ID_REL_EXP_TER IDRELEXPTER, T1.PARTICIPANT_ID PARTICIPANTID, t1.id_tercero IDTERCERO,t2.DOCUMENTO DOCUMENTO FROM REL_EXP_TER T1, DATOS_TERCEROS t2 WHERE t1.id_tercero = T2.ID_TERCERO AND T1.ID_EXPEDIENTE = ?  AND (T1.ID_TIPO_TERCERO = 1 OR T1.ID_TIPO_TERCERO = 3) order by T1.PARTICIPANT_ID";
		List<RelExpTer> relexpterList = this.jdbcTemplate.query(query, this.rwMapValorParticipacion, idExpediente);

		return relexpterList;
	}

	/**
	 * Finds lista de parcicipaciones de la tabla RelExpTer
	 *
	 * @param relexpter
	 *            RelExpTer
	 * @return RelExpTer
	 */
	@Transactional(readOnly = true)
	public List<RelExpTer> findParticipantId(Integer idExpediente) {
		String query = "SELECT t1.PARTICIPANT_ID AS PARTICIPANTID, t1.ID_TERCERO AS DATOSTERCEROSIDTERCERO, t2.DOCUMENTO AS DOCUMENTO, t2.TIPO_PARTICIPANTE AS TIPOPARTICIPANTE FROM REL_EXP_TER t1, DATOS_TERCEROS t2 WHERE t1.ID_TERCERO = t2.ID_TERCERO AND t1.ID_EXPEDIENTE = ? AND t1.PARTICIPANT_ID IS NOT NULL";
		List<RelExpTer> relexpterList = this.jdbcTemplate.query(query, this.rwMapParticipantId, idExpediente);

		return relexpterList;
	}

	/**
	 * Remove a single row in the RelExpTer dado un idTercero
	 *
	 * @param relexpter
	 *            RelExpTer
	 * @return
	 */
	public void removeidTercero(Integer idTercero) {
		String query = "DELETE FROM REL_EXP_TER WHERE ID_TERCERO = ?";
		this.jdbcTemplate.update(query, idTercero);
	}

	/**
	 * Removes a single row in the RelExpTer table.
	 *
	 * @param relexpter
	 *            RelExpTer
	 * @return
	 */
	public void remove(RelExpTer relexpter) {
		String query = "DELETE FROM REL_EXP_TER WHERE ID_REL_EXP_TER=?";
		this.jdbcTemplate.update(query, relexpter.getIdRelExpTer());
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<RelExpTer> getMultiple(RelExpTer filterRelExpTer, TableRequestDto tableRequestDto, Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterRelExpTer, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, RelExpTer.class, params,
				"ID_REL_EXP_TER");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds lista de participantes de la tabla RelExpTer
	 *
	 * @param relexpter
	 *            RelExpTer
	 * @return RelExpTer
	 */
	@Transactional(readOnly = true)
	public List<RelExpTer> findParticipantes(Integer idExpediente) {
		StringBuilder query = new StringBuilder();

		query.append("SELECT t6134.ID_TIPO_TERCERO AS IDTIPOTERCERO");
		query.append(
				", t6106.DESCRIPCION_CASTELLANO AS DESCRIPCIONCASTELLANO, t6106.DESCRIPCION_EUSKERA AS DESCRIPCIONEUSKERA");
		query.append(", t6134.PARTICIPANT_ID AS PARTICIPANTID, t6134.ID_TERCERO AS DATOSTERCEROSIDTERCERO");
		query.append(", t6135.NOMBRE AS NOMBRE, t6135.APELLIDO1 AS APELLIDO1, t6135.APELLIDO2 AS APELLIDO2");
		query.append(", t6135.TIPO_PARTICIPANTE AS DATOSTERCEROSTIPOPARTICIPANTE, t6135.DOCUMENTO AS DOCUMENTO");
		// Tipo de Tercero:
		// 1: Solicitante
		// 3: Afectado
		// 6: Representante Legal
		// 2: Persona de Contacto
		// 7: Denunciado Provisional
		query.append(", DECODE (t6134.ID_TIPO_TERCERO, 1, 1, 2, 4, 3, 2, 6, 3, 7, 5) AS ORDEN");
		query.append(", t6134.ID_REL_EXP_TER IDRELEXPTER, t6134.ID_SUBTIPO_TERCERO IDSUBTIPOTERCERO");
		query.append(", t6136.ID_DIRECCION IDDIRECCION, t6136.ID_PAIS IDPAIS, t6136.ID_PROVINCIA IDPROVINCIA");
		query.append(", t6136.ID_MUNICIPIO IDMUNICIPIO, t6136.ID_LOCALIDAD IDLOCALIDAD, t6136.DIRECCION DIRECCION");
		query.append(
				", t6136.NUMERO NUMERO, t6136.ESCALERA ESCALERA, t6136.PISO PISO, t6136.LETRA LETRA, t6136.CODIGO_POSTAL CODIGOPOSTAL, t6136.COMPLEMENTO_DIRECCION COMPLEMENTODIRECCION");
		query.append(", t6136.DESCRIPCION_CIUDAD DESCRIPCIONCIUDAD, t6136.DESCRIPCION_PROVINCIA DESCRIPCIONPROVINCIA");
		query.append(" FROM REL_EXP_TER t6134");
		query.append(" INNER JOIN DATOS_TERCEROS t6135 ON t6134.ID_TERCERO = t6135.ID_TERCERO");
		query.append(" INNER JOIN TIPOS_TERCERO t6106 ON t6134.ID_TIPO_TERCERO = t6106.ID_TIPO_TERCERO");
		query.append(
				" LEFT OUTER JOIN DATOS_DIRECCIONES t6136 ON t6135.ID_TERCERO = t6136.ID_TERCERO AND t6136.ID_TIPO_DIRECCION = "
						+ Constantes.ID_DIRECCION_POSTAL);
		query.append(" WHERE t6134.ID_EXPEDIENTE = ?");
		query.append(" ORDER BY ORDEN, PARTICIPANTID, DATOSTERCEROSTIPOPARTICIPANTE ASC");

		List<RelExpTer> relexpterList = this.jdbcTemplate.query(query.toString(), this.rwMapParticipantes,
				idExpediente);

		return relexpterList;
	}

	/**
	 * Finds a list of rows in the RelExpTer table.
	 *
	 * @param relexpter
	 *            RelExpTer
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<RelExpTer>
	 */
	@Transactional(readOnly = true)
	public List<RelExpTer> findAll(RelExpTer relexpter, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_REL_EXP_TER IDRELEXPTER,t1.ID_EXPEDIENTE IDEXPEDIENTE,t1.ID_TIPO_TERCERO IDTIPOTERCERO,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.PARTICIPANT_ID PARTICIPANTID,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t2.ID_TERCERO DATOSTERCEROSIDTERCERO,t2.DOCUMENTO DATOSTERCEROSDOCUMENTO,t2.ID_TIPO_DOCUMENTO DATOSTERCEROSIDTIPODOCUMENTO,t2.NOMBRE DATOSTERCEROSNOMBRE,t2.APELLIDO1 DATOSTERCEROSAPELLIDO1,t2.APELLIDO2 DATOSTERCEROSAPELLIDO2,t2.ID_SEXO DATOSTERCEROSIDSEXO,t2.TELEFONO DATOSTERCEROSTELEFONO,t2.EMAIL DATOSTERCEROSEMAIL,t2.IDIOMA DATOSTERCEROSIDIOMA,t2.TIPO_PARTICIPANTE DATOSTERCEROSTIPOPARTICIPANTE,t2.FECHA_REGISTRO DATOSTERCEROSFECHAREGISTRO,t2.USUARIO_REGISTRO DATOSTERCEROSUSUARIOREGISTRO,t2.FECHA_ULTMODIFICACION DATOSTERCEROSFULTMOD,t2.USUARIO_ULTMODIFICACION DATOSTERCEROSUULTMOD,t2.ID_REPRESENTANTE DATOSTERCEROSIDREPRESENTANTE ");
		query.append("FROM REL_EXP_TER t1 ,DATOS_TERCEROS t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(relexpter);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_TERCERO= t2.ID_TERCERO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, RelExpTerDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<RelExpTer>) this.jdbcTemplate.query(query.toString(), this.rwMapSergio, params.toArray());
	}

	/**
	 * Finds rows in the RelExpTer table using like.
	 *
	 * @param relexpter
	 *            RelExpTer
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelExpTer>
	 */
	@Transactional(readOnly = true)
	public List<RelExpTer> findAllLike(RelExpTer relexpter, TableRequestDto tableRequestDto, Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_REL_EXP_TER IDRELEXPTER,t1.ID_EXPEDIENTE IDEXPEDIENTE,t1.ID_TIPO_TERCERO IDTIPOTERCERO,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.PARTICIPANT_ID PARTICIPANTID,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t2.ID_TERCERO DATOSTERCEROSIDTERCERO,t2.DOCUMENTO DATOSTERCEROSDOCUMENTO,t2.ID_TIPO_DOCUMENTO DATOSTERCEROSIDTIPODOCUMENTO,t2.NOMBRE DATOSTERCEROSNOMBRE,t2.APELLIDO1 DATOSTERCEROSAPELLIDO1,t2.APELLIDO2 DATOSTERCEROSAPELLIDO2,t2.ID_SEXO DATOSTERCEROSIDSEXO,t2.TELEFONO DATOSTERCEROSTELEFONO,t2.EMAIL DATOSTERCEROSEMAIL,t2.IDIOMA DATOSTERCEROSIDIOMA,t2.TIPO_PARTICIPANTE DATOSTERCEROSTIPOPARTICIPANTE,t2.FECHA_REGISTRO DATOSTERCEROSFECHAREGISTRO,t2.USUARIO_REGISTRO DATOSTERCEROSUSUARIOREGISTRO,t2.FECHA_ULTMODIFICACION DATOSTERCEROSFULTMOD,t2.USUARIO_ULTMODIFICACION DATOSTERCEROSUULTMOD,t2.ID_REPRESENTANTE DATOSTERCEROSIDREPRESENTANTE ");
		query.append("FROM REL_EXP_TER t1 ,DATOS_TERCEROS t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(relexpter, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_TERCERO= t2.ID_TERCERO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, RelExpTerDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<RelExpTer>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the RelExpTer table.
	 *
	 * @param relexpter
	 *            RelExpTer
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(RelExpTer relexpter) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM REL_EXP_TER t1 , DATOS_TERCEROS t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(relexpter);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_TERCERO= t2.ID_TERCERO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the RelExpTer table using like.
	 *
	 * @param relexpter
	 *            RelExpTer
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(RelExpTer relexpter, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM REL_EXP_TER t1 ,DATOS_TERCEROS t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(relexpter, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_TERCERO= t2.ID_TERCERO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of RelExpTer selected for rup_table
	 *
	 * @param relexpter
	 *            RelExpTer
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpTer>>
	 */
	@Override
	public List<TableRowDto<RelExpTer>> reorderSelection(RelExpTer relexpter, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_REL_EXP_TER IDRELEXPTER,t1.ID_EXPEDIENTE IDEXPEDIENTE,t1.ID_TIPO_TERCERO IDTIPOTERCERO,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.PARTICIPANT_ID PARTICIPANTID,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t2.ID_TERCERO DATOSTERCEROSIDTERCERO,t2.DOCUMENTO DATOSTERCEROSDOCUMENTO,t2.ID_TIPO_DOCUMENTO DATOSTERCEROSIDTIPODOCUMENTO,t2.NOMBRE DATOSTERCEROSNOMBRE,t2.APELLIDO1 DATOSTERCEROSAPELLIDO1,t2.APELLIDO2 DATOSTERCEROSAPELLIDO2,t2.ID_SEXO DATOSTERCEROSIDSEXO,t2.TELEFONO DATOSTERCEROSTELEFONO,t2.EMAIL DATOSTERCEROSEMAIL,t2.IDIOMA DATOSTERCEROSIDIOMA,t2.TIPO_PARTICIPANTE DATOSTERCEROSTIPOPARTICIPANTE,t2.FECHA_REGISTRO DATOSTERCEROSFECHAREGISTRO,t2.USUARIO_REGISTRO DATOSTERCEROSUSUARIOREGISTRO,t2.FECHA_ULTMODIFICACION DATOSTERCEROSFULTMOD,t2.USUARIO_ULTMODIFICACION DATOSTERCEROSUULTMOD,t2.ID_REPRESENTANTE DATOSTERCEROSIDREPRESENTANTE ");
		// FROM
		query.append("FROM REL_EXP_TER t1 ,DATOS_TERCEROS t2 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(relexpter, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_TERCERO= t2.ID_TERCERO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto, RelExpTer.class,
				filterParamList, "ID_REL_EXP_TER");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<RelExpTer>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            RelExpTer
	 * @param searchParams
	 *            RelExpTer
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpTer>>
	 */
	@Override
	public List<TableRowDto<RelExpTer>> search(RelExpTer filterParams, RelExpTer searchParams,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_REL_EXP_TER IDRELEXPTER,t1.ID_EXPEDIENTE IDEXPEDIENTE,t1.ID_TIPO_TERCERO IDTIPOTERCERO,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.PARTICIPANT_ID PARTICIPANTID,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t2.ID_TERCERO DATOSTERCEROSIDTERCERO,t2.DOCUMENTO DATOSTERCEROSDOCUMENTO,t2.ID_TIPO_DOCUMENTO DATOSTERCEROSIDTIPODOCUMENTO,t2.NOMBRE DATOSTERCEROSNOMBRE,t2.APELLIDO1 DATOSTERCEROSAPELLIDO1,t2.APELLIDO2 DATOSTERCEROSAPELLIDO2,t2.ID_SEXO DATOSTERCEROSIDSEXO,t2.TELEFONO DATOSTERCEROSTELEFONO,t2.EMAIL DATOSTERCEROSEMAIL,t2.IDIOMA DATOSTERCEROSIDIOMA,t2.TIPO_PARTICIPANTE DATOSTERCEROSTIPOPARTICIPANTE,t2.FECHA_REGISTRO DATOSTERCEROSFECHAREGISTRO,t2.USUARIO_REGISTRO DATOSTERCEROSUSUARIOREGISTRO,t2.FECHA_ULTMODIFICACION DATOSTERCEROSFULTMOD,t2.USUARIO_ULTMODIFICACION DATOSTERCEROSUULTMOD,t2.ID_REPRESENTANTE DATOSTERCEROSIDREPRESENTANTE ");
		// FROM
		query.append("FROM REL_EXP_TER t1 ,DATOS_TERCEROS t2 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");
		from_alias.add(" t2 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_TERCERO= t2.ID_TERCERO(+) ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto, RelExpTer.class,
				filterParamList, searchSQL, searchParamList, from_alias, "ID_REL_EXP_TER");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<RelExpTer>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filterrelexpter
	 *            RelExpTer
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(RelExpTer filterrelexpter, TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_REL_EXP_TER IDRELEXPTER,t1.ID_EXPEDIENTE IDEXPEDIENTE,t1.ID_TIPO_TERCERO IDTIPOTERCERO,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.PARTICIPANT_ID PARTICIPANTID,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t2.ID_TERCERO DATOSTERCEROSIDTERCERO,t2.DOCUMENTO DATOSTERCEROSDOCUMENTO,t2.ID_TIPO_DOCUMENTO DATOSTERCEROSIDTIPODOCUMENTO,t2.NOMBRE DATOSTERCEROSNOMBRE,t2.APELLIDO1 DATOSTERCEROSAPELLIDO1,t2.APELLIDO2 DATOSTERCEROSAPELLIDO2,t2.ID_SEXO DATOSTERCEROSIDSEXO,t2.TELEFONO DATOSTERCEROSTELEFONO,t2.EMAIL DATOSTERCEROSEMAIL,t2.IDIOMA DATOSTERCEROSIDIOMA,t2.TIPO_PARTICIPANTE DATOSTERCEROSTIPOPARTICIPANTE,t2.FECHA_REGISTRO DATOSTERCEROSFECHAREGISTRO,t2.USUARIO_REGISTRO DATOSTERCEROSUSUARIOREGISTRO,t2.FECHA_ULTMODIFICACION DATOSTERCEROSFULTMOD,t2.USUARIO_ULTMODIFICACION DATOSTERCEROSUULTMOD,t2.ID_REPRESENTANTE DATOSTERCEROSIDREPRESENTANTE ");
		// FROM
		query.append("FROM REL_EXP_TER t1 ,DATOS_TERCEROS t2 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterrelexpter, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto, RelExpTer.class, query,
				params, "ID_REL_EXP_TER");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterRelExpTer
	 *            RelExpTer
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(RelExpTer filterRelExpTer, TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM REL_EXP_TER t1
		// ,DATOS_TERCEROS t2 ");
		List<String> from = new ArrayList<String>();
		from.add("REL_EXP_TER");
		from.add("DATOS_TERCEROS");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");
		from_alias.add(" t2 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterRelExpTer, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_REL_EXP_TER",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterRelExpTer
	 *            RelExpTer
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<RelExpTer>>
	 */
	@Override
	public List<TableRowDto<RelExpTer>> findAllChild(RelExpTer filterRelExpTer, TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM REL_EXP_TER t1
		// ,DATOS_TERCEROS t2 ");
		List<String> from = new ArrayList<String>();
		from.add("REL_EXP_TER");
		from.add("DATOS_TERCEROS");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");
		from_alias.add(" t2 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterRelExpTer, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere, "ID_REL_EXP_TER",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<RelExpTer>(this.rwMapPK, "ID_REL_EXP_TER"), params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the RelExpTer entity
	 *
	 * @param relexpter
	 *            RelExpTer Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(RelExpTer relexpter) {

		StringBuilder where = new StringBuilder(RelExpTerDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (relexpter != null && relexpter.getIdRelExpTer() != null) {
			where.append(" AND t1.ID_REL_EXP_TER = ?");
			params.add(relexpter.getIdRelExpTer());
		}
		if (relexpter != null && relexpter.getDatosTerceros() != null
				&& relexpter.getDatosTerceros().getIdTercero() != null) {
			where.append(" AND t2.ID_TERCERO = ?");
			params.add(relexpter.getDatosTerceros().getIdTercero());
		}

		if (relexpter != null && relexpter.getDatosTerceros() != null
				&& relexpter.getDatosTerceros().getDocumento() != null) {
			where.append(" AND t2.DOCUMENTO = ?");
			params.add(relexpter.getDatosTerceros().getDocumento());
		}
		if (relexpter != null && relexpter.getDatosTerceros() != null
				&& relexpter.getDatosTerceros().getTipoDocumento() != null
				&& relexpter.getDatosTerceros().getTipoDocumento().getIdTipoDocumento() != null) {
			where.append(" AND t2.ID_TIPO_DOCUMENTO = ?");
			params.add(relexpter.getDatosTerceros().getTipoDocumento().getIdTipoDocumento());
		}
		if (relexpter != null && relexpter.getDatosTerceros() != null
				&& relexpter.getDatosTerceros().getNombre() != null) {
			where.append(" AND t2.NOMBRE = ?");
			params.add(relexpter.getDatosTerceros().getNombre());
		}
		if (relexpter != null && relexpter.getDatosTerceros() != null
				&& relexpter.getDatosTerceros().getApellido1() != null) {
			where.append(" AND t2.APELLIDO1 = ?");
			params.add(relexpter.getDatosTerceros().getApellido1());
		}
		if (relexpter != null && relexpter.getDatosTerceros() != null
				&& relexpter.getDatosTerceros().getApellido2() != null) {
			where.append(" AND t2.APELLIDO2 = ?");
			params.add(relexpter.getDatosTerceros().getApellido2());
		}
		if (relexpter != null && relexpter.getDatosTerceros() != null && relexpter.getDatosTerceros().getSexo() != null
				&& relexpter.getDatosTerceros().getSexo().getIdSexo() != null) {
			where.append(" AND t2.ID_SEXO = ?");
			params.add(relexpter.getDatosTerceros().getSexo().getIdSexo());
		}
		if (relexpter != null && relexpter.getDatosTerceros() != null
				&& relexpter.getDatosTerceros().getTelefono() != null) {
			where.append(" AND t2.TELEFONO = ?");
			params.add(relexpter.getDatosTerceros().getTelefono());
		}
		if (relexpter != null && relexpter.getDatosTerceros() != null
				&& relexpter.getDatosTerceros().getEmail() != null) {
			where.append(" AND t2.EMAIL = ?");
			params.add(relexpter.getDatosTerceros().getEmail());
		}
		if (relexpter != null && relexpter.getDatosTerceros() != null
				&& relexpter.getDatosTerceros().getIdioma() != null) {
			where.append(" AND t2.IDIOMA = ?");
			params.add(relexpter.getDatosTerceros().getIdioma());
		}
		if (relexpter != null && relexpter.getDatosTerceros() != null
				&& relexpter.getDatosTerceros().getTipoParticipante() != null) {
			where.append(" AND t2.TIPO_PARTICIPANTE = ?");
			params.add(relexpter.getDatosTerceros().getTipoParticipante());
		}
		if (relexpter != null && relexpter.getDatosTerceros() != null
				&& relexpter.getDatosTerceros().getUsuarioRegistro() != null) {
			where.append(" AND t2.USUARIO_REGISTRO = ?");
			params.add(relexpter.getDatosTerceros().getUsuarioRegistro());
		}
		if (relexpter != null && relexpter.getDatosTerceros() != null
				&& relexpter.getDatosTerceros().getUsuarioUltmodificacion() != null) {
			where.append(" AND t2.USUARIO_ULTMODIFICACION = ?");
			params.add(relexpter.getDatosTerceros().getUsuarioUltmodificacion());
		}
		if (relexpter != null && relexpter.getIdExpediente() != null) {
			where.append(" AND t1.ID_EXPEDIENTE = ?");
			params.add(relexpter.getIdExpediente());
		}
		if (relexpter != null && relexpter.getTiposTercero() != null
				&& relexpter.getTiposTercero().getIdTipoTercero() != null) {
			where.append(" AND t1.ID_TIPO_TERCERO = ?");
			params.add(relexpter.getTiposTercero().getIdTipoTercero());
		}
		if (relexpter != null && relexpter.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(relexpter.getUsuarioRegistro());
		}
		if (relexpter != null && relexpter.getParticipantId() != null) {
			where.append(" AND t1.PARTICIPANT_ID = ?");
			params.add(relexpter.getParticipantId());
		}
		if (relexpter != null && relexpter.getUsuarioUltmodificacion() != null) {
			where.append(" AND t1.USUARIO_ULTMODIFICACION = ?");
			params.add(relexpter.getUsuarioUltmodificacion());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the RelExpTer entity
	 *
	 * @param relexpter
	 *            RelExpTer Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(RelExpTer relexpter, Boolean startsWith) {

		StringBuilder where = new StringBuilder(RelExpTerDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (relexpter != null && relexpter.getIdRelExpTer() != null) {
			where.append(" AND t1.ID_REL_EXP_TER = ?");
			params.add(relexpter.getIdRelExpTer());
		}
		if (relexpter != null && relexpter.getDatosTerceros() != null
				&& relexpter.getDatosTerceros().getIdTercero() != null) {
			where.append(" AND t2.ID_TERCERO = ?");
			params.add(relexpter.getDatosTerceros().getIdTercero());
		}

		if (relexpter != null && relexpter.getDatosTerceros() != null
				&& relexpter.getDatosTerceros().getDocumento() != null) {
			where.append(" AND UPPER(t2.DOCUMENTO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(relexpter.getDatosTerceros().getDocumento().toUpperCase() + "%");
			} else {
				params.add("%" + relexpter.getDatosTerceros().getDocumento().toUpperCase() + "%");
			}
			where.append(" AND t2.DOCUMENTO IS NOT NULL");
		}
		if (relexpter != null && relexpter.getDatosTerceros() != null
				&& relexpter.getDatosTerceros().getTipoDocumento() != null
				&& relexpter.getDatosTerceros().getTipoDocumento().getIdTipoDocumento() != null) {
			where.append(" AND t2.ID_TIPO_DOCUMENTO = ?");
			params.add(relexpter.getDatosTerceros().getTipoDocumento().getIdTipoDocumento());
		}
		if (relexpter != null && relexpter.getDatosTerceros() != null
				&& relexpter.getDatosTerceros().getNombre() != null) {
			where.append(" AND UPPER(t2.NOMBRE) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(relexpter.getDatosTerceros().getNombre().toUpperCase() + "%");
			} else {
				params.add("%" + relexpter.getDatosTerceros().getNombre().toUpperCase() + "%");
			}
			where.append(" AND t2.NOMBRE IS NOT NULL");
		}
		if (relexpter != null && relexpter.getDatosTerceros() != null
				&& relexpter.getDatosTerceros().getApellido1() != null) {
			where.append(" AND UPPER(t2.APELLIDO1) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(relexpter.getDatosTerceros().getApellido1().toUpperCase() + "%");
			} else {
				params.add("%" + relexpter.getDatosTerceros().getApellido1().toUpperCase() + "%");
			}
			where.append(" AND t2.APELLIDO1 IS NOT NULL");
		}
		if (relexpter != null && relexpter.getDatosTerceros() != null
				&& relexpter.getDatosTerceros().getApellido2() != null) {
			where.append(" AND UPPER(t2.APELLIDO2) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(relexpter.getDatosTerceros().getApellido2().toUpperCase() + "%");
			} else {
				params.add("%" + relexpter.getDatosTerceros().getApellido2().toUpperCase() + "%");
			}
			where.append(" AND t2.APELLIDO2 IS NOT NULL");
		}
		if (relexpter != null && relexpter.getDatosTerceros() != null && relexpter.getDatosTerceros().getSexo() != null
				&& relexpter.getDatosTerceros().getSexo().getIdSexo() != null) {
			where.append(" AND t2.ID_SEXO = ?");
			params.add(relexpter.getDatosTerceros().getSexo().getIdSexo());
		}
		if (relexpter != null && relexpter.getDatosTerceros() != null
				&& relexpter.getDatosTerceros().getTelefono() != null) {
			where.append(" AND t2.TELEFONO = ?");
			params.add(relexpter.getDatosTerceros().getTelefono());
		}
		if (relexpter != null && relexpter.getDatosTerceros() != null
				&& relexpter.getDatosTerceros().getEmail() != null) {
			where.append(" AND UPPER(t2.EMAIL) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(relexpter.getDatosTerceros().getEmail().toUpperCase() + "%");
			} else {
				params.add("%" + relexpter.getDatosTerceros().getEmail().toUpperCase() + "%");
			}
			where.append(" AND t2.EMAIL IS NOT NULL");
		}
		if (relexpter != null && relexpter.getDatosTerceros() != null
				&& relexpter.getDatosTerceros().getIdioma() != null) {
			where.append(" AND t2.IDIOMA = ?");
			params.add(relexpter.getDatosTerceros().getIdioma());
		}
		if (relexpter != null && relexpter.getDatosTerceros() != null
				&& relexpter.getDatosTerceros().getTipoParticipante() != null) {
			where.append(" AND t2.TIPO_PARTICIPANTE = ?");
			params.add(relexpter.getDatosTerceros().getTipoParticipante());
		}
		if (relexpter != null && relexpter.getDatosTerceros() != null
				&& relexpter.getDatosTerceros().getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t2.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(relexpter.getDatosTerceros().getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + relexpter.getDatosTerceros().getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t2.USUARIO_REGISTRO IS NOT NULL");
		}
		if (relexpter != null && relexpter.getDatosTerceros() != null
				&& relexpter.getDatosTerceros().getUsuarioUltmodificacion() != null) {
			where.append(" AND UPPER(t2.USUARIO_ULTMODIFICACION) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(relexpter.getDatosTerceros().getUsuarioUltmodificacion().toUpperCase() + "%");
			} else {
				params.add("%" + relexpter.getDatosTerceros().getUsuarioUltmodificacion().toUpperCase() + "%");
			}
			where.append(" AND t2.USUARIO_ULTMODIFICACION IS NOT NULL");
		}
		if (relexpter != null && relexpter.getIdExpediente() != null) {
			where.append(" AND t1.ID_EXPEDIENTE = ?");
			params.add(relexpter.getIdExpediente());
		}
		if (relexpter != null && relexpter.getTiposTercero().getIdTipoTercero() != null) {
			where.append(" AND t1.ID_TIPO_TERCERO = ?");
			params.add(relexpter.getTiposTercero().getIdTipoTercero());
		}
		if (relexpter != null && relexpter.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(relexpter.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + relexpter.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}
		if (relexpter != null && relexpter.getParticipantId() != null) {
			where.append(" AND UPPER(t1.PARTICIPANT_ID) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(relexpter.getParticipantId().toUpperCase() + "%");
			} else {
				params.add("%" + relexpter.getParticipantId().toUpperCase() + "%");
			}
			where.append(" AND t1.PARTICIPANT_ID IS NOT NULL");
		}
		if (relexpter != null && relexpter.getUsuarioUltmodificacion() != null) {
			where.append(" AND UPPER(t1.USUARIO_ULTMODIFICACION) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(relexpter.getUsuarioUltmodificacion().toUpperCase() + "%");
			} else {
				params.add("%" + relexpter.getUsuarioUltmodificacion().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_ULTMODIFICACION IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;
}
